(function () {
    'use strict';

    angular.module('starter')
        .config(config)
        .config(datePicker);

    config.$inject = ['$logProvider', '$ionicConfigProvider', '$httpProvider'];
    datePicker.$inject = ['ionicDatePickerProvider'];

    function config ($logProvider, $ionicConfigProvider, $httpProvider) {
        $logProvider.debugEnabled(true);
        $ionicConfigProvider.tabs.position('bottom');
        $httpProvider.interceptors.push(('requestInterceptor'));
    }

    function datePicker (ionicDatePickerProvider) {
      var datePickerObj = {
        inputDate: new Date(),
        setLabel: '确认',
        todayLabel: '今日',
        closeLabel: '关闭',
        mondayFirst: false,
        weeksList: ["日", "一", "二", "三", "四", "五", "六"],
        monthsList: ["一月", "二月", "三月", "四月", "五月", "六月", "七月", "八月", "九月", "十月", "十一月", "十二月"],
        templateType: 'popup',
        from: new Date(1950, 8, 1),
        to: new Date(2018, 8, 1),
        showTodayButton: true,
        dateFormat: 'yyyy-MM-dd',
        closeOnSelect: false,
        disableWeekdays: []
      };
      ionicDatePickerProvider.configDatePicker(datePickerObj);
    }


})();
