// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter.utils', []);
angular.module('starter.filters', []);
angular.module('starter.controllers', []);
angular.module('starter.services', []);
angular.module('starter.directives', []);

angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'starter.utils', 'starter.filters', 'starter.directives', 'ionic-datepicker'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs).
    // The reason we default this to hidden is that native apps don't usually show an accessory bar, at
    // least on iOS. It's a dead giveaway that an app is using a Web View. However, it's sometimes
    // useful especially with forms, though we would prefer giving the user a little more room
    // to interact with the app.
    if (window.cordova && window.Keyboard) {
      window.Keyboard.hideKeyboardAccessoryBar(true);
    }

    if (window.StatusBar) {
      // Set the statusbar to use the default style, tweak this to
      // remove the status bar on iOS or change it to use white instead of dark colors.
      StatusBar.styleDefault();
    }
  });
});

angular.module('starter').factory('requestInterceptor', ['$q',
function ($q) {
  let requestInterceptor = {
    request: function (config) {
      let deferred = $q.defer();
      deferred.resolve(config);
      return deferred.promise;
    },
    response: function (rep) {
      // if (rep && rep.code == 401) {
      //   $state.go('login');
      // }
      return rep;
    },
    responseError: function (rep) {
      if (rep && rep.data && rep.data.code == 401) {
        // $state.go('login');
        location.hash = '#/login';
      }
      return rep;
    }
  };
  return requestInterceptor
}]);
