(function () {
    'use strict';
    angular.module('starter')
        .config(route);

    route.$inject = ['$stateProvider', '$urlRouterProvider'];

    function route ($stateProvider, $urlRouterProvider) {
        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider
            .state('tab', {
                url: '/tab',
                abstract: true,
                templateUrl: 'templates/tabs.html'
            })
            .state('tab.home', {
                url: '/home?:categoryId',
                cache: false,
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/home.html',
                        controller: 'HomeCtrl as hm',
                        params: {
                          categoryId: null
                        }
                    }
                }
            })
            .state('tab.category', {
              url: '/category',
              views: {
                'tab-default': {
                  templateUrl: 'templates/default/category.html',
                  controller: 'CategoryCtrl as ca'
                }
              }
            })
            .state('tab.task', {
              url: '/task/:taskId',
              views: {
                'tab-default': {
                  templateUrl: 'templates/default/task-details.html',
                  controller: 'TaskDetailsCtrl as td'
                }
              }
            })
            .state('tab.taskPublish', {
              url: '/task/publish/:taskId',
              views: {
                'tab-default': {
                  templateUrl: 'templates/default/task-publish.html',
                  controller: 'TaskPublishCtrl as tp'
                }
              }
            })
            .state('tab.labor', {
              url: '/labor/:laborId',
              views: {
                'tab-default': {
                  templateUrl: 'templates/default/labor-details.html',
                  controller: 'LaborDetailsCtrl as ld'
                }
              }
            })
            .state('tab.company', {
              url: '/company/:companyId',
              views: {
                'tab-default': {
                  templateUrl: 'templates/default/company-details.html',
                  controller: 'CompanyDetailsCtrl as cd'
                }
              }
            })
            /*.state('tab.search', {
                url: '/search',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/search.html',
                        controller: 'SearchCtrl as sh'
                    }
                }
            })
            .state('tab.category', {
                url: '/category',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/search.html',
                        controller: 'SearchCtrl as sh'
                    }
                }
            })
            .state('tab.store', {
                url: '/store/:storeId',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/store.html',
                        controller: 'StoreCtrl as sr'
                    }
                }
            })
            .state('tab.storeAlbum', {
                url: '/store-album/:storeId',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/store-album.html',
                        controller: 'StoreAlbumCtrl as sa'
                    }
                }
            })
            .state('tab.itemList', {
                url: '/item-list',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/item-list.html',
                        controller: 'ItemListCtrl as il'
                    }
                },
                cache: false
            })
            .state('tab.goods', {
                url: '/goods/:goodsId',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/goods.html',
                        controller: 'GoodsCtrl as gd'
                    }
                }
            })
            .state('tab.goodsDetails', {
                url: '/goods/:goodsId/details',
                views: {
                    'tab-default': {
                        templateUrl: 'templates/default/goods-details.html',
                        controller: 'GoodsDetailsCtrl as gds'
                    }
                }
            })
            .state('tab.goodsDetails.desc', {
                url: '/desc',
                templateUrl: 'templates/default/goods-details-desc.html'
            })
            .state('tab.goodsDetails.params', {
                url: '/params',
                templateUrl: 'templates/default/goods-details-params.html'
            })*/

            .state('tab.tasks', {
              url: '/tasks?:status',
              cache: false,
              views: {
                'tab-tasks': {
                  templateUrl: 'templates/task/task.html',
                  controller: 'TaskCtrl as tk',
                  params: {
                    status: null
                  }
                }
              }
            })

            .state('tab.message', {
                url: '/message/:messageId',
                views: {
                    'tab-messages': {
                        templateUrl: 'templates/message/message.html',
                        controller: 'MessageCtrl as msg'
                    }
                }
            })
            .state('tab.messageList', {
                url:'/message-list',
                views: {
                    'tab-messages': {
                        templateUrl: 'templates/message/message-list.html',
                        controller: 'MessageListCtrl as ml'
                    }
                }
            })

            .state('tab.user', {
                url: '/user',
                views: {
                    'tab-user': {
                        templateUrl: 'templates/user/user.html',
                        controller: 'UserCtrl as ur'
                    }
                }
            })
            .state('tab.userProfile', {
                url: '/user/user-profile',
                views: {
                    'tab-user': {
                        templateUrl: 'templates/user/user-profile.html',
                        controller: 'UserProfileCtrl as up'
                    }
                }
            })
            .state('tab.userComplete', {
              url: '/user/user-complete',
              views: {
                'tab-user': {
                  templateUrl: 'templates/user/user-complete.html',
                  controller: 'UserCompleteCtrl as uc'
                }
              }
            })
            .state('tab.userIdentify', {
              url: '/user/user-identify',
              views: {
                'tab-user': {
                  templateUrl: 'templates/user/user-identify.html',
                  controller: 'UserIdentifyCtrl as ud'
                }
              }
            })
            .state('tab.userPrivacy', {
              url: '/user/user-privacy',
              views: {
                'tab-user': {
                  templateUrl: 'templates/user/user-privacy.html',
                  controller: 'UserPrivacyCtrl as uv'
                }
              }
            })

            /*.state('tab.userFavorite', {
                url: '/user-favorite',
                views: {
                    'tab-user': {
                        templateUrl: 'templates/user/user-favorite.html',
                        controller: 'UserFavoriteCtrl as uf'
                    }
                }
            })*/

            /*.state('tab.userStore', {
                url: '/user-store',
                views: {
                    'tab-store': {
                        templateUrl: 'templates/store/user-store.html',
                        controller: 'UserStoreCtrl as us'
                    }
                }
            })*/
            /*.state('tab.goodsCategory', {
                url: '/goods-category',
                views: {
                    'tab-store': {
                        templateUrl: 'templates/store/goods-category.html',
                        controller: 'GoodsCategoryCtrl as gc'
                    }
                }
            })
            .state('tab.goodsManage', {
                url: '/goods-manage',
                views: {
                    'tab-store': {
                        templateUrl: 'templates/store/goods-manage.html',
                        controller: 'GoodsManageCtrl as gm'
                    }
                }
            })
            .state('tab.editGoods', {
                url: '/edit-goods/:goodsId',
                views: {
                    'tab-store': {
                        templateUrl: 'templates/store/add-goods.html',
                        controller: 'AddGoodsCtrl as ag'
                    }
                }
            })*/

            /*.state('tab.setting', {
                url: '/setting',
                views: {
                    'tab-setting': {
                        templateUrl: 'templates/setting/setting.html',
                        controller: 'SettingCtrl as st'
                    }
                }
            })*/
            .state('intro', {
              url: '/',
              templateUrl: 'templates/intro.html',
              controller: 'IntroCtrl as in'
            })
            .state('login', {
                cache: false,
                url: '/login',
                templateUrl: 'templates/user/login.html',
                controller: 'LoginCtrl as lg'
            })
            .state('register', {
                cache: false,
                url: '/register',
                templateUrl: 'templates/user/register.html',
                controller: 'RegisterCtrl as rs'
            })
            .state('forgetPassword', {
                cache: false,
                url: '/forget-password',
                templateUrl: 'templates/user/forget-password.html',
                controller: 'ForgetPasswordCtrl as fp'
            })
            .state('changePassword', {
                cache: false,
                url: '/change-password',
                templateUrl: 'templates/user/change-password.html',
                controller: 'ChangePasswordCtrl as cp'
            })


        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/tab/home');
    }
})();
