(function () {
  'use strict';

  angular.module('starter.controllers')
    .controller('CategoryCtrl', CategoryCtrl);

  CategoryCtrl.$inject = ['$scope', '$state', 'dataService'];

  function CategoryCtrl ($scope, $state, dataService) {

    var _this = this;

    this.currentCategoryId = -1; // 选中的分类id
    this.subCategories = [];    // 选中二级分类列表

    this.changeCategory = changeCategory;
    this.changeSubCategory = changeSubCategory;

    init();

    function init () {
      dataService.get('/task/categories')
       .then(function (resp) {
         _this.categories = resp.data;
         _this.categories.unshift({
           categoryId: -1,
           categoryName: '全部分类'
         });
         _generateSubCategory(-1);
       });
    }

    /**
     * 切换分类
     */
    function changeCategory(category) {
      this.currentCategoryId = category.categoryId;
      _generateSubCategory(category.categoryId);
    }

    /**
     * 切换二级分类
     */
    function changeSubCategory(subCategory) {
      $state.go('tab.home', {categoryId: subCategory.categoryId});
    }

    /**
     * 生成二级分类
     */
    function _generateSubCategory(categoryId) {
      _this.subCategories.length = 0;
      _this.categories.forEach(function (category) {
        if (category.subCategories && (categoryId == category.categoryId || categoryId == -1)) {
          _this.subCategories = _this.subCategories.concat(category.subCategories);
        }
      })
    }
  }
})();
