(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('ChangePasswordCtrl', ChangePasswordCtrl);

    ChangePasswordCtrl.$inject = ['$scope', '$state', '$ionicPopup', '$timeout', 'dataService', 'localDataService'];

    function ChangePasswordCtrl ($scope, $state, $ionicPopup, $timeout, dataService, localDataService) {
        var _this = this;
        _this.data = {};

        _this.nextStep = nextStep;
        _this.changePhone = changePhone;
        _this.sendVerificationCode = sendVerificationCode;
        _this.submit = submit;

        init();

        function init () {
            _this.step = 'one';
            _this.user = localDataService.getUser();
        }

        function nextStep () {
            _this.step = 'two';
        }

        function changePhone () {
            $scope.data = {
                msg: _this.user.phone
            };
            var myPopup = $ionicPopup.show({
                template: '<input auto-focus auto-focus-enable="true" type="text" ng-model="data.msg">',
                title: '手机号码',
                scope: $scope,
                buttons: [
                    { text: '取消' },
                    {
                        text: '<b>保存</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            if (!$scope.data.msg) {
                                //don't allow the user to close unless he enters wifi password
                                e.preventDefault();
                            } else {
                                return $scope.data.msg;
                            }
                        }
                    }
                ]
            });
            myPopup.then(function(res) {
                if (res) {
                    _this.user.phone = res;
                }
            });
        }

        function sendVerificationCode () {
            dataService.post('/reset-verification-code', {phoneNumber: _this.data.phoneNumber})
                .then(function (resp) {
                    if (resp.status == 'succeed') {
                        $ionicPopup.alert({
                            template: "验证码已经发送到手机" + _this.data.phoneNumber + "上，请注意查收！"
                        });
                    } else if (resp.status == 'failure') {
                        $ionicPopup.alert({
                            template: resp.error.message
                        });
                    }
                })
        }

        function submit () {
            _this.step = 'three';
            dataService.post('', {newPassword: _this.data.newPassword, verificationCode: _this.data.verificationCode})
                .then(function (resp) {
                    if (resp && resp.status == 'succeed') {
                        $timeout(function () {
                            $state.go('tab.user');
                        }, 2000);
                    }
                });
        }

    }

})();