(function () {
  'use strict';

  angular.module('starter.controllers')
    .controller('ForgetPasswordCtrl', ForgetPasswordCtrl);

  ForgetPasswordCtrl.$inject = ['$scope', '$state', '$ionicPopup', 'dataService'];

  function ForgetPasswordCtrl($scope, $state, $ionicPopup, dataService) {

    var _this = this;

    this.step = 'one';
    this.mobile = '';           // 手机号
    this.password = '';         // 新密码
    this.confirmPassword = '';  // 确认密码
    this.captcha = '';          // 验证码

    this.sendCaptcha = sendCaptcha;
    this.next = next;
    this.resetPassword = resetPassword;

    /**
     * 发送验证码
     */
    function sendCaptcha() {
      dataService.get('/smsVerify/' + _this.mobile)
        .then(function (resp) {
          if (resp.code === 200) {
            $ionicPopup.alert({
              template: "验证码已经发送到手机" + _this.mobile + "上，请注意查收！"
            });
          } else {$ionicPopup.alert({
              template: resp.message
            });
          }
        })
    }

    /**
     * 下一步
     */
    function next() {
      // todo 检查手机号是否存在，验证码是否正确
      _this.step = 'two';
      /*dataService.post('/check-phone-number', {phoneNumber: _this.data.phoneNumber, verificationCode: _this.data.verificationCode})
          .then(function (resp) {
              if (resp.status == 'succeed') {
                  _this.step = 'two';
              } else if (resp.status == 'failure') {
                  $ionicPopup.alert({
                      template: resp.error.message
                  });
              }
          })*/
    }

    /**
     * 重置密码
     */
    function resetPassword() {
      dataService.post('/reset-password', {
        mobile: _this.mobile,
        password: _this.password,
        captcha: _this.captcha
      })
        .then(function (resp) {
          if (resp && resp.code == 200) {
            $ionicPopup.alert({
              title: '密码修改成功！',
              template: ''
            })
              .then(function (res) {
                $state.go('login');
              });
          } else if (resp && resp.code == 400) {
            $ionicPopup.alert({
              title: resp && resp.message,
              template: ''
            });
          }
        });
    }
  }

})();
