(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('GoodsCtrl', GoodsCtrl);

    GoodsCtrl.$inject = ['$scope', '$state', '$stateParams', '$ionicPopup', '$ionicModal', 'dataService', 'serverUrl'];

    function GoodsCtrl ($scope, $state, $stateParams, $ionicPopup, $ionicModal, dataService, serverUrl) {
        var _this = this;
        _this.goodsId = $stateParams.goodsId;
        _this.slideIndex = 1;
        _this.slideLength = 0;
        _this.onSlideChanged = onSlideChanged;
        _this.share = share;
        _this.goHome = goHome;
        _this.follow = follow;
        _this.comment = comment;
        _this.previewImage = previewImage;

        init();

        function init () {
            dataService.get('/goods/' + _this.goodsId)
                .then(function (resp) {
                    _this.goods = resp.goods;
                    _this.slideLength = _this.goods.pictures.length;
                    //$ionicSlideBoxDelegate.$getByHandle('img-viewer').update();
                });
            $scope.$on('$destroy', function () {
                _this.modal && _this.modal.remove();
            })
        }

        function onSlideChanged (index) {
            _this.slideIndex = index + 1;
        }

        function share () {
            _this.showMore = false;
            // todo
        }

        function goHome () {
            _this.showMore = false;
            $state.go('tab.home');
        }

        function follow () {
            dataService.post('/fav/add', {type: 'goods', id: _this.goods.id})
                .then(function (data) {
                    _this.goods.followCount++;
                });
        }

        function comment (replyTo) {
            $scope.data = {};
            var myPopup = $ionicPopup.show({
                template: '<input auto-focus auto-focus-enable="true" type="text" ng-model="data.msg">',
                title: '评论',
                scope: $scope,
                buttons: [
                    { text: '取消' },
                    {
                        text: '<b>保存</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            if (!$scope.data.msg) {
                                //don't allow the user to close unless he enters wifi password
                                e.preventDefault();
                            } else {
                                return $scope.data.msg;
                            }
                        }
                    }
                ]
            });
            myPopup.then(function(res) {
                console.log('Tapped!', res);
                // todo leave message
                /*if (!res) {
                    dataService.post('/messages', {type: 'goods', replyTo: replyTo ? replyTo : -1, content: res});
                }*/
            });
        }

        function previewImage (img) {
            var imgUrl = serverUrl + '/' + img;
            var template = '<ion-modal-view class="preview-img"><img src="' + imgUrl +'" ng-click="sr.closePreviewImage()"></ion-modal-view>';
            _this.modal = $ionicModal.fromTemplate(template, {scope: $scope, animation: 'slide-in-up'});
            _this.modal.show();
        }

        function closePreviewImage () {
            _this.modal.remove();
        }

    }

})();