(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('GoodsManageCtrl', GoodsManageCtrl);

    GoodsManageCtrl.$inject = ['$scope', '$state', 'dataService', 'localDataService'];

    function GoodsManageCtrl ($scope, $state, dataService, localDataService) {

        var _this = this;
        _this.goods = [];
        _this.moreDataCanBeLoaded = true;

        _this.deleteGoods = deleteGoods;
        _this.loadMore = loadMore;

        init();

        function init () {
            _this.store = localDataService.getUserStore();
            _this.formatSearchCondition = {
                type: 'all',
                keyword1: '',
                keyword2: '',
                keyword3: '',
                storeId: _this.store.id,
                start: 0
            };
            // todo get goods
            /*dataService.post('/search/goods', _this.formatSearchCondition)
                .then(function (resp) {
                    _this.goods = resp.result;
                });*/
            _this.goods = [
                {
                    followCount: 0,
                    id: 867,
                    image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                    name: "黑白罗汉",
                    price: 40000
                },
                {
                    followCount: 0,
                    id: 866,
                    image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                    name: "一代天骄",
                    price: 43000
                },
                {
                    followCount: 0,
                    id: 865,
                    image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                    name: "悟道",
                    price: 43000
                },
                {
                    followCount: 0,
                    id: 864,
                    image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                    name: "红颜",
                    price: 45000
                },
                {
                    followCount: 0,
                    id: 863,
                    image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                    name: "龙",
                    price: 100000
                },
                {
                    followCount: 0,
                    id: 862,
                    image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                    name: "江南水乡",
                    price: 70000
                }
            ]

        }

        function deleteGoods (goodsId) {
            // todo
            /*dataService.del('/user-store/goods/' + goodsId)
                .then(function (resp) {
                    if (resp.result == 'succeed') {
                        _.remove(_this.goods, function (item) {
                            return item.id == goodsId;
                        })
                    }
                })*/
            _.remove(_this.goods, function (item) {
                return item.id == goodsId;
            })
        }

        function loadMore () {
            _this.formatSearchCondition.start = _this.goods.length;
            dataService.post('/search/goods', _this.formatSearchCondition)
                .then(function (resp) {
                    if (resp.result.length == 0) {
                        _this.moreDataCanBeLoaded = false;
                    }
                    for (var i in resp.result) {
                        _this.goods.push(resp.result[i]);
                    }
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                });
        }

    }
})();