(function () {
  'use strict';

  angular.module('starter.controllers')
    .controller('LoginCtrl', LoginCtrl);

  LoginCtrl.$inject = ['$scope', '$state', 'dataService', 'localDataService', '$ionicPopup'];

  function LoginCtrl($scope, $state, dataService, localDataService, $ionicPopup) {
    var _this = this;
    _this.user = {
      mobile: '',
      password: ''
    };
    _this.login = login;

    init();
    function init () {
      // 第一次运行APP，进入介绍页面
      if (!localStorage.getItem('intro')) {
        $state.go('intro');
      }
    }

    function login() {
      dataService.post('/login', _this.user)
        .then(function (resp) {
          if (resp.code === 200) {
            localDataService.setUserStore(resp.data.user);
            localStorage.setItem('loginUser', JSON.stringify(resp.data.user));
            localStorage.setItem('Authorization', resp.data.user.token);
            localDataService.setToken(resp.data.user.token);
            $state.go('tab.home');
          } else if (resp.code === 400) {
            $ionicPopup.alert({
              title: resp && resp.message,
              template: ''
            });
          }
        })
    }
  }

})();
