(function () {
  'use strict';

  angular.module('starter.controllers')
    .controller('MessageListCtrl', MessageListCtrl);

  MessageListCtrl.$inject = ['$scope', '$state', '$stateParams', '$ionicPopup', 'dataService'];

  function MessageListCtrl($scope, $state, $stateParams, $ionicPopup, dataService) {

    let _this = this;
    _this.messages = [];    // 消息列表
    _this.totalMessages = 0;
    _this.param = {
      pageNo: 0,    // 页码，从1开始
      pageSize: 10  // 页长
    };

    _this.search = search;
    _this.deleteMsg = deleteMsg;

    init();

    /**
     * 初始化
     */
    function init() {
      search();
    }

    /**
     * 查询消息
     */
    function search () {
      _this.param.pageNo++;
      dataService.get('/messages', _this.param)
        .then(function (resp) {
          _this.messages = _this.messages.concat(resp.data.data);
          _this.totalMessages = resp.data.total;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    }

    /**
     * 删除消息
     */
    function deleteMsg (message) {
      dataService.del('/messages/' + message.id)
        .then(function (resp) {
          _this.messages.splice(_this.messages.indexOf(message), 1);
        })
    }

  }

})();
