(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('RegisterCtrl', RegisterCtrl);

    RegisterCtrl.$inject = ['$scope', '$state', '$ionicPopup', 'dataService', 'localDataService'];

    function RegisterCtrl ($scope, $state, $ionicPopup, dataService, localDataService) {
        var _this = this;
        _this.data = {
          username: '',
          mobile: '',
          password: '',
          captcha: '',
          userType: ''  // 1:company, 2:personal
        };
        _this.step = 'one';

        _this.sendCaptcha = sendCaptcha;
        _this.selectUserType = selectUserType;
        _this.next = next;
        _this.register = register;

        /**
         * 发送验证码
         */
        function sendCaptcha () {
          dataService.get('/smsVerify/' + _this.data.mobile)
            .then(function (resp) {
              if (resp.code === 200) {
                $ionicPopup.alert({
                  template: "验证码已经发送到手机" + _this.data.mobile + "上，请注意查收！"
                });
              } else {$ionicPopup.alert({
                template: resp.message
              });
              }
            })
        }

        /**
         * 选择用户类型
         */
        function selectUserType (type) {
          _this.data.userType = type;
          _this.step = 'two';
        }

        /**
         * 下一步
         */
        function next () {
          // todo 检查手机号是否存在，验证码是否正确
          _this.step = 'three';
            /*dataService.post('/check-phone-number', {phoneNumber: _this.data.phoneNumber, verificationCode: _this.data.verificationCode})
                .then(function (resp) {
                    if (resp.status == 'succeed') {
                        _this.step = 'two';
                    } else if (resp.status == 'failure') {
                        $ionicPopup.alert({
                            template: resp.error.message
                        });
                    }
                })*/
        }

        /**
         * 注册
         */
        function register () {
            dataService.post('/register', _this.data)
                .then(function (resp) {
                  if (resp && resp.code == 200) {
                    localDataService.setUserStore(resp.data.user);
                    localStorage.setItem('Authorization', resp.data.user.token);
                    localDataService.setToken(resp.data.user.token);
                    $state.go('tab.home');
                  } else if (resp && resp.code == 400) {
                    $ionicPopup.alert({
                      title: resp && resp.message,
                      template: ''
                    });
                  }
                });
        }
    }

})();
