(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('SearchCtrl', SearchCtrl);

    SearchCtrl.$inject = ['$scope', '$state', 'dataService', 'localDataService'];

    function SearchCtrl ($scope, $state, dataService, localDataService) {
        var _this = this;

        _this.searchTypeTxt = '玉器';
        _this.searchType = 'goods';
        _this.keyword = '';
        _this.hideSearchType = true;
        _this.autoFocusEnable = false;
        _this.stateName = $state.current.name;
        _this.selectedCategory;

        _this.toggleSearchType = toggleSearchType;
        _this.chooseSearchType = chooseSearchType;
        _this.search = search;
        _this.changeCategory = changeCategory;
        _this.changeSubCategory = changeSubCategory;

        if (_this.stateName == 'tab.search') {
            initSearch();
        } else if (_this.stateName == 'tab.category') {
            initCategory();
        }

        function initSearch () {
            _this.autoFocusEnable = true;
        }

        function initCategory () {
            _this.categories = localDataService.getCategories();
            if (!_this.categories) {
                dataService.get('/categories')
                    .then(function (data) {
                        _this.categories =  data.categories;
                        localDataService.setCategories(_this.categories);
                        if (_this.categories && _this.categories.length > 0) {
                            _this.selectedCategory = _this.categories[0];
                        }
                    })
            }
        }

        function toggleSearchType () {
            _this.hideSearchType = !_this.hideSearchType;
        }

        function chooseSearchType (searchType) {
            _this.searchType = searchType;
            if (searchType == 'goods') {
                _this.searchTypeTxt = '玉器';
            } else if (searchType == 'store') {
                _this.searchTypeTxt = '店铺';
            }
            toggleSearchType();
        }

        function search () {
            localDataService.setSearchCondition({
                searchType: _this.searchType,
                keyword: _this.keyword
            });
            $state.go('tab.itemList');
        }

        function changeCategory (category) {
            if (!_this.selectedCategory || (category && category.Id != _this.selectedCategory)) {
                _this.selectedCategory = category;
            }
        }

        function changeSubCategory (obj) {
            localDataService.setSearchCondition({searchType: 'goods', categoryId: obj.categoryId, subCategoryId: obj.subCategoryId});
            $state.go('tab.itemList');
        }

    }

})();