(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('StoreCtrl', StoreCtrl);

    StoreCtrl.$inject = ['$scope', '$state', '$stateParams', '$ionicActionSheet', '$ionicPopup', '$ionicModal', 'dataService', 'localDataService', 'serverUrl'];

    function StoreCtrl ($scope, $state, $stateParams, $ionicActionSheet, $ionicPopup, $ionicModal, dataService, localDataService, serverUrl) {
        var _this = this;
        _this.storeId = $stateParams.storeId;
        _this.categories = [];

        _this.goGoodsList = goGoodsList;
        _this.showStoreOptions = showStoreOptions;
        _this.showCategories = showCategories;
        _this.showContactStore = showContactStore;
        _this.previewImage = previewImage;
        _this.closePreviewImage = closePreviewImage;
        _this.follow = follow;
        _this.goToItem = goToItem;

        init();

        function init () {
            // todo just for test
            /*dataService.get('/stores/' + _this.storeId)
                .then(function (resp) {
                    _this.store = resp.store;
                    localDataService.setStore(_this.store);
                });
            dataService.get('/stores/'  + _this.storeId + '/categories')
                .then(function (resp) {
                    _this.categories = resp.categories;
                });*/
            _this.store = {
                "id": 198,
                "name": "安琪玉雕工作室",
                "image": "uploadfiles/shop/2015/08/11/image016.jpg",
                "avatar": "uploadfiles/shop/2015/08/11/image006.jpg",
                "followCount": 101,
                "goods": [
                    {
                        "followCount": 0,
                        "id": 867,
                        "image": "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        "name": "黑白罗汉",
                        "price": 40000,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "一代天骄",
                        id: 866,
                        price: 43000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "悟道",
                        id: 865,
                        price: 43000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "红颜",
                        id: 864,
                        price: 45000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "龙",
                        id: 863,
                        price: 100000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "和田玉印章",
                        id: 862,
                        price: 70000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "金钱缠身",
                        id: 863,
                        price: 100000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    },
                    {
                        name: "江南水乡",
                        id: 862,
                        price: 70000,
                        image: "uploadfiles/goods/2015/08/25/thumb_2015082503024723.jpg",
                        followCount: 0,
                        "store": {
                            id: 55,
                            name: "尚玉雅集"
                        }
                    }
                ],
                "certificates": ["uploadfiles/shop/2015/08/11/image005.jpg", "uploadfiles/shop/2015/08/11/image006.jpg", "uploadfiles/shop/2015/08/11/image007.jpg"],
                "tel": "12345678901"
            };
            localDataService.setStore(_this.store);
            _this.categories = [
                {"id": 1, "name": "人物"},
                {"id": 2, "name": "鸟兽"},
                {"id": 3, "name": "蔬菜"},
                {"id": 4, "name": "情侣对佩"},
                {"id": 5, "name": "花草鱼虫"},
                {"id": 6, "name": "吉祥寓意"},
                {"id": 7, "name": "典故传说"}
            ];

            $scope.$on('$destroy', function () {
                _this.modal && _this.modal.remove();
            })
        }

        function goGoodsList () {
            localDataService.setSearchCondition({
                searchType: 'goods',
                storeId: _this.storeId
            });
            $state.go('tab.itemList');
        }

        function showStoreOptions () {
            $ionicActionSheet.show({
                buttons: [
                    {text: '店铺介绍'},
                    {text: '店铺相册'}
                ],
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:

                            break;
                        case 1:
                            $state.go('tab.storeAlbum', {storeId: _this.storeId});
                            break;
                        default :
                            ;
                    }
                }
            })
        }

        function showCategories () {
            for (var i in _this.categories) {
                _this.categories[i].text = _this.categories[i].name;
            }
            if (_this.categories && _this.categories.length) {
                $ionicActionSheet.show({
                    buttons: _this.categories,
                    buttonClicked: function (index) {
                        localDataService.setSearchCondition({
                            searchType: 'goods',
                            storeId: _this.storeId,
                            storeCategoryId: _this.categories[i].id
                        });
                        $state.go('tab.itemList');
                    }
                })
            }
        }

        function showContactStore () {
            var hideSheet = $ionicActionSheet.show({
                buttons: [
                    {text: '电话'},
                    {text: '留言'}
                ],
                buttonClicked: function (index) {
                    switch (index) {
                        case 0:
                            document.location.href = 'tel:' + _this.store.tel;
                            hideSheet();
                            break;
                        case 1:
                            _leaveMessage();
                            hideSheet();
                            break;
                        default :
                            ;
                    }
                }
            })
        }

        function follow () {
            dataService.post('/fav/add', {type: 'store', id: _this.store.id});
        }

        function goToItem (item) {
            $state.go('tab.goods', {goodsId: item.id});
        }

        function previewImage (img) {
            var imgUrl = serverUrl + '/' + img;
            var template = '<ion-modal-view class="preview-img"><img src="' + imgUrl +'" ng-click="sr.closePreviewImage()"></ion-modal-view>';
            _this.modal = $ionicModal.fromTemplate(template, {scope: $scope, animation: 'slide-in-up'});
            _this.modal.show();
        }

        function closePreviewImage () {
            _this.modal.remove();
        }

        function _leaveMessage () {
            $scope.data = {};
            var myPopup = $ionicPopup.show({
                template: '<input auto-focus auto-focus-enable="true" type="text" ng-model="data.msg">',
                title: '留言',
                scope: $scope,
                buttons: [
                    { text: '取消' },
                    {
                        text: '<b>保存</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            if (!$scope.data.msg) {
                                //don't allow the user to close unless he enters wifi password
                                e.preventDefault();
                            } else {
                                return $scope.data.msg;
                            }
                        }
                    }
                ]
            });
            myPopup.then(function(res) {
                console.log('Tapped!', res);
                // todo leave message
                /*if (!res) {
                    dataService.post('/messages', {type: 'toStore', replyTo: -1, content: res});
                }*/
            });
        }
    }

})();