(function () {
  'use strict';

  angular.module('starter.controllers')
    .controller('TaskDetailsCtrl', TaskDetailsCtrl);

  TaskDetailsCtrl.$inject = ['$state', '$stateParams', '$ionicSlideBoxDelegate', 'dataService', 'localDataService'];

  function TaskDetailsCtrl ($state, $stateParams, $ionicSlideBoxDelegate, dataService, localDataService) {
    let _this = this;
    _this.taskId = $stateParams.taskId;
    _this.insure = true; // 是否投保
    _this.addToFavorite = addToFavorite;
    _this.share = share;
    _this.goHome = goHome;
    _this.applyJob = applyJob;
    _this.deleteTask = deleteTask;
    _this.editTask = editTask;
    _this.viewCompany = viewCompany;

    init();

    function init () {
      dataService.get('/task/'+ $stateParams.taskId)
        .then(function (resp) {
          _this.task = resp.data;
        });

      if(!localDataService.getUser()){
        dataService.get('/user/currentUser')
          .then(function (resp) {
            _this.user = resp.data;
            localDataService.setUser(_this.user);
          });
      }else{
        _this.user = localDataService.getUser();
      }
    }

    /**
     * 加入收藏
     */
    function addToFavorite () {
      // todo
    }

    /**
     * 分享
     */
    function share () {
      _this.showMore = false;
      // todo
    }

    /**
     * 返回首页
     */
    function goHome () {
      _this.showMore = false;
      $state.go('tab.home');
    }

    /**
     * 申请工作
     */
    function applyJob () {
      dataService.post('/task/' + $stateParams.taskId + '/apply?insure=' + (_this.insure ? 1 : 0))
        .then(function (resp) {
          $state.go('tab.tasks');
        });
    }

    function deleteTask () {
      dataService.del('/task/'+$stateParams.taskId)
        .then(function (resp) {
          $state.go('tab.home');
        });
    }

    function editTask () {
      $state.go('tab.taskPublish', {
        taskId: $stateParams.taskId
      });
    }

    function viewCompany () {
      $state.go('tab.company', {
        companyId: _this.task.companyId
      });
    }
  }

})();
