(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('UserCtrl', UserCtrl);

    UserCtrl.$inject = ['$scope', '$state', 'dataService', 'localDataService'];

    function UserCtrl ($scope, $state, dataService, localDataService) {
        var _this = this;

        _this.user = localDataService.getUser();
        if (!_this.user) {
            dataService.get('/user/currentUser')
             .then(function (resp) {
             _this.user = resp.data;
             localDataService.setUser(_this.user);
             });
        }

        _this.logout = function () {
          localDataService.setUser(null);
          localStorage.removeItem('Authorization');
          localDataService.setToken('');
          location.href="#/login";
        }
    }

})();
