(function () {
    'use strict';

    angular.module('starter.controllers')
        .controller('UserFavoriteCtrl', UserFavoriteCtrl);

    UserFavoriteCtrl.$inject = ['$scope', '$state', 'dataService'];

    function UserFavoriteCtrl ($scope, $state, dataService) {
        var _this = this;
        _this.type = 'goods'; // goods | stores

        _this.changeType = changeType;
        _this.removeFavorite = removeFavorite;

        init();

        function init () {
            changeType('goods');
        }

        function changeType (type) {
            _this.type = type;
            dataService.get('/fav/' + (type == 'store' ? 'stores' : type))
                .then(function (resp) {
                    _this.items = resp.result;
                });
        }

        function removeFavorite (itemId) {
            dataService.post('/fav/delete', {type:_this.type, id: itemId})
                .then(function (resp) {
                    _.remove(_this.items, function (item) {
                        return item.id == itemId;
                    })
                });
        }

    }

})();