(function () {
    'use strict';

    angular.module('starter.directives')
        .directive('tyItem', tyItem);

    tyItem.$inject = ['localDataService', 'dataService'];

    function tyItem (localDataService, dataService) {
        return {
            restrict: 'AE',
            replace: true,
            templateUrl: 'templates/directive/tpl-item.html',
            scope: {
                item: '=',
                type: '=',
                goodsType: '=',
                removeFav: '&'
            },
            link: function (scope, element, attrs) {
                scope.follow = follow;
                scope.clickStar = clickStar;

                function follow () {
                    event.stopPropagation();
                    if (!scope.type || !localDataService.getToken()) {
                        return;
                    }
                    dataService.post('/fav/add', {type: scope.type, id: scope.item.id})
                        .then(function (data) {
                            scope.item.followCount++;
                        });
                }

                function clickStar () {
                    scope.removeFav({itemId: scope.item.id});
                }
            }
        }
    }
})();