(function () {
  'use strict';
  angular.module('starter.services')
    .service('fileUpload', fileUpload);

  fileUpload.$inject = ['$http', '$q', '$log', 'serverUrl', 'localDataService'];

  function fileUpload($http, $q, $log, serverUrl, localDataService) {
    var self = this;
    var xhr;
    var ot;//
    var oloaded;
    var url = serverUrl + 'job-serve' + '/resource/uploadOne';
    self.callback  = null;
    self.upload = function (file, cb) {
      self.callback = cb;
      //var fileObj = document.getElementById("file").files[0]; // js 获取文件对象
      var form = new FormData(); // FormData 对象
      form.append("file", file); // 文件对象
      xhr = new XMLHttpRequest();  // XMLHttpRequest 对象
      xhr.open("post", url, true); //post方式，url为服务器请求地址，true 该参数规定请求是否异步处理。
      xhr.setRequestHeader('Authorization', localDataService.getToken());
      xhr.onload = uploadComplete.bind(cb); //请求完成
      xhr.onerror = uploadFailed; //请求失败
      xhr.upload.onprogress = progressFunction;//【上传进度调用方法实现】
      xhr.upload.onloadstart = function () {//上传开始执行方法
        ot = new Date().getTime();   //设置上传开始时间
        oloaded = 0;//设置上传开始时，以上传的文件大小为0
      };
      xhr.send(form); //开始上传，发送form数据
    };

    function progressFunction(evt) {
    }

    function uploadComplete(evt) {
      self.callback(JSON.parse(evt.currentTarget.response));
    }

    function uploadFailed(evt) {
      console.log(evt);
    }

    function cancleUploadFile() {
      xhr.abort();
    }
  }
})();
